product/urls.py
from django.urls import path
from . import views


urlpatterns = [
    path('list/', views.ProductList.as_view()),
    path('create/', views.ProductCreate.as_view()),
    path('<int:pk>/', views.ProductDetail.as_view()),
]

shop/urls.py
from django.contrib import admin
from django.urls import path, include
from user.views import index, RegisterView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', index),
    path('user/', include('user.urls')),
    path('product/', include('product.urls')),
]

user/urls.py
from django.urls import path
from . import views


urlpatterns = [
    path('register/', views.RegisterView.as_view()),
    path('login/', views.LoginView.as_view()),
]

order/models.py
from django.db import models


class Order(models.Model):
    user = models.ForeignKey(
        'user.User', on_delete=models.CASCADE, verbose_name='사용자')
    product = models.ForeignKey(
        'product.Product', on_delete=models.CASCADE, verbose_name='상품')
    quantity = models.IntegerField(verbose_name='수량')
    register_date = models.DateTimeField(
        auto_now_add=True, verbose_name='등록일시')

    def __str__(self):
        return str(self.user) + ' ' + str(self.product)

    class Meta:
        db_table = 'ORDER'
        verbose_name = '주문'
        verbose_name_plural = '주문'

product/models.py
from django.db import models


class Product(models.Model):
    name = models.CharField(max_length=256, verbose_name='상품명')
    price = models.IntegerField(verbose_name='상품가격')
    description = models.TextField(verbose_name='상품설명')
    stock = models.IntegerField(verbose_name='재고')
    register_date = models.DateTimeField(auto_now_add=True, verbose_name='등록일시')

    def __str__(self):
        return self.name

    class Meta:
        db_table = 'PRODUCT'
        verbose_name = '상품'
        verbose_name_plural = '상품'

user/models.py
from django.db import models


class User(models.Model):
    email = models.EmailField(verbose_name='이메일')
    password = models.CharField(max_length=64, verbose_name='비밀번호')
    register_date = models.DateTimeField(auto_now_add=True, verbose_name='등록일시')

    def __str__(self):
        return self.email

    class Meta:
        db_table = 'USER'
        verbose_name = '사용자'
        verbose_name_plural = '사용자'

order/forms.py
from django import forms
from .models import Order


class RegisterForm(forms.Form):
    quantity = forms.IntegerField(
        error_messages={
            'required': '수량을 입력하세요!'
        }, label='수량'
    )
    product = forms.IntegerField(
        error_messages={
            'required': '상품 입력하세요!'
        }, label='상품가격', widget=forms.HiddenInput
    )

    def clean(self):
        # 템플릿에서 받아온 데이터를 딕셔너리로 할당
        cleaned_data = super().clean()
        # 딕셔너리 데이터를 키별로 할당한다

product/forms.py
from django import forms
from .models import Product


class RegisterForm(forms.Form):
    name = forms.CharField(
        error_messages={
            'required': '상품명을 입력하세요!'
        }, max_length=64, label='상품명'
    )
    price = forms.IntegerField(
        error_messages={
            'required': '가격을 입력하세요!'
        }, label='상품가격'
    )
    description = forms.CharField(
        error_messages={
            'required': '상품내용을 입력하세요!'
        }, label='상품설명'
    )
    stock = forms.IntegerField(
        error_messages={
            'required': '재고를 입력하세요!'
        }, label='재고'
    )

    def clean(self):
        # 템플릿에서 받아온 데이터를 딕셔너리로 할당
        cleaned_data = super().clean()
        # 딕셔너리 데이터를 키별로 할당한다
        name = cleaned_data.get('name')
        price = cleaned_data.get('price')
        description = cleaned_data.get('description')
        stock = cleaned_data.get('stock')

        if name and price and description and stock:
            product = Product(
                name=name,
                price=price,
                description=description,
                stock=stock
            )
            # db에 저장하기
            product.save()

user/forms.py
from django import forms
from .models import User
from django.contrib.auth.hashers import make_password, check_password


class RegisterForm(forms.Form):
    # 템플릿에서 받아올 data 형식
    email = forms.EmailField(
        error_messages={
            'required': '이메일을 입력하세요!'
        }, max_length=64, label='이메일'
    )
    password = forms.CharField(
        error_messages={
            'required': '비밀번호를 입력하세요!'
        }, widget=forms.PasswordInput, label='비밀번호'
    )
    re_password = forms.CharField(
        error_messages={
            'required': '비밀번호를 입력하세요!'
        }, widget=forms.PasswordInput, label='비밀번호 확인'
    )

    # 받은 데이터 유효성 검사
    def clean(self):
        # 템플릿에서 받아온 데이터를 딕셔너리로 할당
        cleaned_data = super().clean()
        # 딕셔너리 데이터를 키별로 할당한다
        email = cleaned_data.get('email')
        password = cleaned_data.get('password')
        re_password = cleaned_data.get('re_password')

        if password and re_password:
            if password != re_password:
                self.add_error('password', '비밀번호가 다릅니다.')
                self.add_error('re_password', '비밀번호가 다릅니다.')
            else:
                # db에 저장할 사용자 인스턴스 생성
                user = User(
                    email=email,
                    password=make_password(password)
                )
                # db에 저장하기
                user.save()


class LoginForm(forms.Form):
    # 템플릿에서 받아올 data 형식
    email = forms.EmailField(
        error_messages={
            'required': '이메일을 입력하세요!'
        }, max_length=64, label='이메일'
    )
    password = forms.CharField(
        error_messages={
            'required': '비밀번호를 입력하세요!'
        }, widget=forms.PasswordInput, label='비밀번호'
    )

    # 받은 데이터 유효성 검사
    def clean(self):
        # 템플릿에서 받아온 데이터를 딕셔너리로 할당
        cleaned_data = super().clean()
        # 딕셔너리 데이터를 키별로 할당한다
        email = cleaned_data.get('email')
        password = cleaned_data.get('password')

        if email and password:
            try:
                user = User.objects.get(email=email)
            except User.DoesNotExist:
                self.add_error('email', '이메일이 없습니다.')
                return

            if not check_password(password, user.password):
                self.add_error('password', '비밀번호가 다릅니다.')
            else:
                self.email = user.email

order/views.py
from django.shortcuts import render

# Create your views here.

product/views.py
from django.shortcuts import render
from django.views.generic import ListView, DetailView
from django.views.generic.edit import FormView

from .forms import RegisterForm
from .models import Product


class ProductList(ListView):
    model = Product
    template_name = 'product/product.html'
    context_object_name = 'product_list'


class ProductCreate(FormView):
    template_name = 'product/register_product.html'
    form_class = RegisterForm
    success_url = '/product/list/'


class ProductDetail(DetailView):
    template_name = 'product/product_detail.html'
    queryset = Product.objects.all()
    context_object_name = 'product'

user/views.py
from django.shortcuts import render
from django.views.generic.edit import FormView
from .forms import RegisterForm, LoginForm


def index(request):
    return render(request, 'index.html', {'email': request.session.get('user')})


class RegisterView(FormView):
    # 요청받은 회원가입 페이지로 랜더링 하면 form 을 함께 넘긴다.
    template_name = 'user/register.html'
    # forms 에 있는 폼을 뷰에 등록여 것
    form_class = RegisterForm
    success_url = '/'


class LoginView(FormView):
    template_name = 'user/login.html'
    form_class = LoginForm
    success_url = '/'

    def form_valid(self, form):
        self.request.session['user'] = form.email

        return super().form_valid(form)

templates/base.html
<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
      integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T"
      crossorigin="anonymous"
    />
    <script
      src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
      integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"
      integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"
      integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM"
      crossorigin="anonymous"
    ></script>
    {% block header %}
    {% endblock %}

  </head>
  <body class="container">
    {% block contents %}{% endblock %}
  </body>
</html>

templates/index.html
{% extends 'base.html' %}
{% block contents %}
    Hello World
    {{ email }}
{% endblock %}

templates/product/product.html
{% extends 'base.html' %}
{% load humanize %}
{% block contents %}
    <div class="row mt-5">
        <div class="col-12">
            <table class="table table-light">
                <thead class="thead-light">
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">상품명</th>
                    <th scope="col">가격</th>
                    <th scope="col">등록날짜</th>
                </tr>
                </thead>
                <tbody class="text-dark">
                {% for product in product_list %}
                <tr>
                    <th scope="row">{{ product.id }}</th>
                    <th><a href="/product/{{ product.id }}">{{ product.name }}</a></th>
                    <th>{{ product.price|intcomma }}원</th>
                    <th>{{ product.register_date|date:'Y-m-d H:i' }}</th>
                </tr>
                {% endfor %}
                </tbody>
            </table>
        </div>
    </div>

{% endblock %}

templates/product/product_detail.html
{% extends 'base.html' %}
{% load humanize %}
{% block contents %}
    <div class="row mt-5">
        <div class="col-12">
            <div class="card" style="width: 100%;">
                <div class="card-body">
                    <h5 class="card-title">{{ product.name }}</h5>
                </div>
                <ul class="list-group list-group-flush">
                    <li class="list-group-item">
                        <form></form>
                    </li>
                    <li class="list-group-item">가   격: {{ product.price|intcomma }}원</li>
                    <li class="list-group-item">등록일시: {{ product.register_date|date:'Y-m-d H:i' }}</li>
                    <li class="list-group-item">{{ product.description|safe }}</li>
                </ul>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <a href="/product/list/">목록보기</a>
        </div>
    </div>

{% endblock %}

templates/product/register_product.html
{% extends "base.html" %}
{% block header %}
    <link href="https://cdn.jsdelivr.net/npm/summernote@0.8.18/dist/summernote-bs4.min.css" rel="stylesheet">
    <script src="https://cdn.jsdelivr.net/npm/summernote@0.8.18/dist/summernote-bs4.min.js"></script>
    <script>
    $(document).ready(function() {
        $('#id_description').summernote({
            height: 300
        });
    });
  </script>
{% endblock %}

{% block contents %}
<div class="row mt-5">
    <div class="col-12 text-center">
        <h1>상품생성</h1>
    </div>
</div>
<div class="row mt-5">
    <div class="col-12">
        {{ error }}
    </div>
</div>
<div class="row">
    <div class="col-12">
        <form method="POST" action=".">
            {% csrf_token %}
            {% for field in form %}
            <div class="form-group">
                <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                {% ifequal field.name 'description' %}
                <textarea class="form-control" name="{{ field.name }}" id="{{ field.id_for_label }}"></textarea>
                {% else %}
                <input type="{{ field.field.widget.input_type }}" class="form-control"
                       id="{{ field.id_for_label }}" placeholder="{{ field.label }}" name="{{ field.name }}"/>
                {% endifequal %}
            </div>
            {% if field.errors %}
            <span style="color: red">{{ field.errors }}</span>
            {% endif %}
            {% endfor %}
            <button type="submit" class="btn btn-primary">생성</button>
        </form>
    </div>
</div>
{% endblock %}

templates/user/login.html
{% extends "base.html" %}

{% block contents %}
<div class="row mt-5">
    <div class="col-12 text-center">
        <h1>로그인</h1>
    </div>
</div>
<div class="row mt-5">
    <div class="col-12">
        {{ error }}
    </div>
</div>
<div class="row">
    <div class="col-12">
        <form method="POST" action=".">
            {% csrf_token %}
            {% for field in form %}
            <div class="form-group">
                <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                <input type="{{ field.field.widget.input_type }}" class="form-control"
                       id="{{ field.id_for_label }}" placeholder="{{ field.label }}" name="{{ field.name }}"/>
            </div>
            {% if field.errors %}
            <span style="color: red">{{ field.errors }}</span>
            {% endif %}
            {% endfor %}
            <button type="submit" class="btn btn-primary">로그인</button>
        </form>
    </div>
</div>
{% endblock %}

templates/user/register.html
{% extends "base.html" %}

{% block contents %}
<div class="row mt-5">
    <div class="col-12 text-center">
        <h1>회원가입</h1>
    </div>
</div>
<div class="row mt-5">
    <div class="col-12">
        {{ error }}
    </div>
</div>
<div class="row">
    <div class="col-12">
        <form method="POST" action=".">
            {% csrf_token %}
            {% for field in form %}
            <div class="form-group">
                <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                <input type="{{ field.field.widget.input_type }}" class="form-control"
                       id="{{ field.id_for_label }}" placeholder="{{ field.label }}" name="{{ field.name }}"/>
            </div>
            {% if field.errors %}
            <span style="color: red">{{ field.errors }}</span>
            {% endif %}
            {% endfor %}
            <button type="submit" class="btn btn-primary">회원가입</button>
        </form>
    </div>
</div>
{% endblock %}